import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:mobile_ui/mobile_ui.dart';
import 'package:mobile_ui/mobile_utils.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatelessWidget {
  const MyApp({Key? key}) : super(key: key);

  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Demo',
      theme: ThemeData(
        // This is the theme of your application.
        //
        // Try running your application with "flutter run". You'll see the
        // application has a blue toolbar. Then, without quitting the app, try
        // changing the primarySwatch below to Colors.green and then invoke
        // "hot reload" (press "r" in the console where you ran "flutter run",
        // or simply save your changes to "hot reload" in a Flutter IDE).
        // Notice that the counter didn't reset back to zero; the application
        // is not restarted.
        primarySwatch: Colors.blue,
      ),
      home: const MyHomePage(title: 'Flutter Demo Home Page'),
    );
  }
}

class MyHomePage extends StatefulWidget {
  const MyHomePage({Key? key, required this.title}) : super(key: key);

  // This widget is the home page of your application. It is stateful, meaning
  // that it has a State object (defined below) that contains fields that affect
  // how it looks.

  // This class is the configuration for the state. It holds the values (in this
  // case the title) provided by the parent (in this case the App widget) and
  // used by the build method of the State. Fields in a Widget subclass are
  // always marked "final".

  final String title;

  @override
  State<MyHomePage> createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  int _counter = 0;
  final formKey = GlobalKey<FormState>();
  late final ValueController<num?> _deliverQtyController =
      ValueController<num?>(1);
  String? xx = '';

  void _incrementCounter() {
    setState(() {
      // This call to setState tells the Flutter framework that something has
      // changed in this State, which causes it to rerun the build method below
      // so that the display can reflect the updated values. If we changed
      // _counter without calling setState(), then the build method would not be
      // called again, and so nothing would appear to happen.
      _counter++;
    });
  }

  @override
  Widget build(BuildContext context) {
    final date = DateTime(2021, 11, 11);
    // This method is rerun every time setState is called, for instance as done
    // by the _incrementCounter method above.
    //
    // The Flutter framework has been optimized to make rerunning build methods
    // fast, so that you can just rebuild anything that needs updating rather
    // than having to individually change instances of widgets.
    return Scaffold(
      appBar: AppBar(
        // Here we take the value from the MyHomePage object that was created by
        // the App.build method, and use it to set our appbar title.
        title: Text(widget.title),
      ),
      body: Center(
        // Center is a layout widget. It takes a single child and positions it
        // in the middle of the parent.
        child: Form(
          key: formKey,
          child: Column(
            mainAxisAlignment: MainAxisAlignment.start,
            crossAxisAlignment: CrossAxisAlignment.stretch,
            children: <Widget>[
              Text(
                'You have pushed the button this many times:${_counter.toString()}',
              ),
              // TextFormField(),
              // TextFormInput(
              //   labelText: 'BC No:',
              //   orientation: FieldOrientation.horizontal,
              //   textType: TextType.password,
              //   isRequired: true,
              //   isDense: true,
              //   backgroudStyle: FormInputBackgroundStyle(
              //       borderWidth: 1, borderColor: Colors.grey[300]),
              // ),
              TextFormInput(
                labelText: 'XX:',
                isRequired: true,
                isDense: true,
                onSaved: (value) => xx = value,
                backgroudStyle: FormInputBackgroundStyle(
                    borderWidth: 1, borderColor: Colors.grey[300]),
              ),
              // Row(
              //   mainAxisAlignment: MainAxisAlignment.spaceBetween,
              //   children: [
              //     const Expanded(
              //       child: Text('dfsfdsfsdf:'),
              //       flex: 100,
              //     ),
              //     Expanded(
              //       child: DropDownFormInput<String>(
              //         isRequired: true,
              //         options: [
              //           DropDownOption(
              //               value: '1', text: 'Pick UP Point 8 | 拾取点8')
              //         ],
              //         isDense: true,
              //         backgroudStyle: FormInputBackgroundStyle(
              //             borderWidth: 1, borderColor: Colors.grey[300]),
              //         margin: EdgeInsets.all(0),
              //         onSaved: (value) {},
              //       ),
              //       flex: 120,
              //     )
              //   ],
              // ),
              // NumFormInput(
              //   labelText: 'dfs',
              //   valueController: _deliverQtyController,
              //   backgroudStyle: FormInputBackgroundStyle(
              //       borderWidth: 1, borderColor: Colors.grey[300]),
              //   minValue: 0,
              //   isDense: true,
              //   fractionDigits: 2,
              //   step: 1,
              //   isRequired: true,
              //   includeMinValue: false,
              //   suffix: Label(
              //     'KG',
              //     color: Colors.black38,
              //   ),
              //   onSaved: (val) {
              //     setState(() {
              //       _counter = val?.toInt() ?? 0;
              //     });
              //   },
              // ),
              // DatePickerFormInput(
              //   labelText: null,
              //   backgroudStyle: FormInputBackgroundStyle(
              //       borderWidth: 1, borderColor: Colors.grey[300]),
              //   margin: const EdgeInsets.only(bottom: 8),
              //   mode: CupertinoDatePickerMode.date,
              //   format: formatDateSG,
              //   orientation: FieldOrientation.horizontal,
              //   canClear: true,
              //   isRequired: true,
              //   isDense: true,
              //   onSaved: (val) {},
              // ),
              Button(
                  text: 'Save',
                  buttonStyle: CustomButtonStyle(
                      buttonType: ButtonType.raised,
                      color: Colors.blue,
                      textColor: Colors.white),
                  onAsyncPressed: () async {
                    //await Future.delayed(const Duration(seconds: 5));
                    debugPrint('onPressed');
                    if (formKey.currentState!.validate()) {
                      formKey.currentState!.save();
                      debugPrint('text: $xx');
                    }
                  }),
              Button(
                  text: 'Reset',
                  buttonStyle: CustomButtonStyle(
                      buttonType: ButtonType.raised,
                      color: Colors.blue,
                      textColor: Colors.white),
                  onAsyncPressed: () async {
                    formKey.currentState!.reset();
                  }),
              Label('date: ${date}'),
              Label('date.addDuration(): ${date.addDuration(months: -21)}'),
            ],
          ),
        ),
      ),
      floatingActionButton: FloatingActionButton(
        onPressed: () {
          _deliverQtyController.value = 7;
        },
        tooltip: 'Increment',
        child: const Icon(Icons.add),
      ), // This trailing comma makes auto-formatting nicer for build methods.
    );
  }
}
