import 'package:flutter/material.dart';

import 'form_input_base.dart';

class CheckboxFormInput extends FormInputBase<bool?> {
  CheckboxFormInput(
      {Key? key,
      String? labelText,
      bool? initialValue,
      ValueController<bool>? controller,
      FocusNode? focusNode,
      bool readOnly = false,
      bool enabled = true,
      bool tristate = false,
      bool isRequired = false,
      bool? isDense,
      FormFieldSetter<bool?>? onSaved,
      ValueValidator<bool?>? validator,
      ValueChanged<bool?>? onChanged,
      AutovalidateMode? autovalidateMode,
      TextAlign labelAlign = TextAlign.left,
      FieldOrientation orientation = FieldOrientation.horizontal,
      EdgeInsetsGeometry contentPadding = const EdgeInsets.all(0),
      EdgeInsetsGeometry margin = const EdgeInsets.symmetric(vertical: 8),
      ControlPosition controlPosition = ControlPosition.trailing,
      double spacingFlactor = 1,
      double? labelWidth,
      int errorMaxLines = 1})
      : super(
          key: key,
          initialValue: controller != null
              ? null
              : (tristate == true ? initialValue : (initialValue ?? false)),
          onSaved: onSaved,
          labelWidth: labelWidth,
          isRequired: isRequired,
          validator: validator,
          enabled: enabled,
          autovalidateMode: autovalidateMode,
          orientation: orientation,
          controlPosition: controlPosition,
          spacingFlactor: spacingFlactor,
          labelText: labelText,
          onChanged: onChanged,
          isDense: isDense,
          labelAlign: labelAlign,
          valueController: controller,
          contentPadding: contentPadding,
          margin: margin,
          errorMaxLines: errorMaxLines,
          // ignore: missing_return
          builder: (field) {
            FormInputBase<bool?> widget = field.widget as FormInputBase<bool?>;
            FormInputStateBase<bool?> state =
                field as FormInputStateBase<bool?>;
            var checkbox = Checkbox(
                focusNode: focusNode,
                tristate: tristate,
                onChanged: enabled == true
                    ? (value) {
                        if (readOnly == true) return;
                        state.changeValue(value);
                      }
                    : null,
                value: state.effectiveValueController!.value,
                materialTapTargetSize: MaterialTapTargetSize.shrinkWrap);
            return widget.buildField(field, checkbox);
          },
        );
}
