const List<int> _multiples = [2, 7, 6, 5, 4, 3, 2];

String? validateNric(String value, int accountNoType, String dob) {
  if (value.isEmpty) return 'This field cannot be empty';
  final firstChar = value[0].toUpperCase();
  final lastChar = value[value.length - 1].toUpperCase();
  var outputChars = <String>[];
  switch (accountNoType) {
    case 1: // SP
    case 2: // SH
    case 3: // SB
      if (firstChar == 'S') {
        outputChars = ['J', 'Z', 'I', 'H', 'G', 'F', 'E', 'D', 'C', 'B', 'A'];
      } else if (firstChar == 'T') {
        outputChars = ['G', 'F', 'E', 'D', 'C', 'B', 'A', 'J', 'Z', 'I', 'H'];
      }
      break;
    case 4: // FIN
      if (firstChar == 'F') {
        outputChars = ['X', 'W', 'U', 'T', 'R', 'Q', 'P', 'N', 'M', 'L', 'K'];
      } else if (firstChar == 'G') {
        outputChars = ['R', 'Q', 'P', 'N', 'M', 'L', 'K', 'X', 'W', 'U', 'T'];
      }
      break;
    default:
      return null;
  }

  if (value.length != 9) {
    return 'Account number must be 9 digits';
  }

  var _value = value.toUpperCase();
  var _numericAccountNo = _value.substring(1, value.length - 1);
  var numericExp = RegExp(r'^\d+$');

  if (!numericExp.hasMatch(_numericAccountNo)) {
    return 'Invalid account number structure';
  }

  var _numberAccountNo = double.tryParse(_numericAccountNo);
  var _total = 0.0;
  var count = 0;

  while (_numberAccountNo != 0) {
    _total += (_numberAccountNo! % 10) *
        _multiples[_multiples.length - (1 + count++)];
    _numberAccountNo /= 10;
    _numberAccountNo = _numberAccountNo.floor().toDouble();
  }
  var expectedLastCharIndex = (_total % 11).toInt();
  var expectedLastChar = outputChars[expectedLastCharIndex];
  if (_total % 11 > outputChars.length - 1 || lastChar != expectedLastChar) {
    return ' Invalid account number structure';
  }

  if (dob.isNotEmpty) {
    final DateTime? dateOfBirth =
        dob.runtimeType == DateTime ? dob as DateTime? : DateTime.tryParse(dob);
    switch (accountNoType) {
      case 1:
      case 2:
      case 3:
        if (dateOfBirth!.year >= 2000) {
          if (firstChar != 'T') return 'Invalid date of birth';
        } else if (firstChar != 'S') return 'Invalid date of birth';

        break;
      default:
        return null;
    }
  }
  return null;
}
